//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include "queues.h"
extern int get_auth_level();
//mqd_t mq_cmd = -1, mq_out = -1;
//ssize_t mq_size = 0;

void print_messages(){
		ssize_t cur, n;
//		unsigned prio;
		mq_getattr(mq_out, &attr);
		cur = attr.mq_curmsgs;
		while(cur-- > 0){
			//n = mq_receive(mq_out, out_buf, attr.mq_msgsize, &prio);
			n = mq_receive(mq_out, out_buf, attr.mq_msgsize, NULL);
			if(n < 1) continue;
			out_buf[n] = 0;
			printf("%s", out_buf);
		}
}

int main(int argc, char **argv){
	printf("Content-type: multipart/form-data; charset=koi8-r\n\n");
/*	if((al = get_auth_level()) < 3){
		printf("   (%d)    .\n", al);
		printf("           3.\n");
		exit(1);
	}
*/	mq_out = mq_open(OUT_QUEUE, O_RDONLY|O_NONBLOCK);
	if(mq_out < 0){perror("mq_out"); printf("err"); exit(1);}
	mq_cmd = mq_open(CMD_QUEUE, O_WRONLY|O_NONBLOCK);
	if(mq_cmd < 0){perror("mq_cmd"); printf("err"); exit(1);}
		if(mq_getattr(mq_cmd, &attr) < 0){printf(" \n");exit(1);}
	if(mq_getattr(mq_out, &attr) < 0){printf(" \n");exit(1);}
	mq_size = attr.mq_msgsize;
	if((in_buf = (char*)calloc(mq_size, 1)) == NULL){printf("   \n");exit(1);}
	if((out_buf= (char*)calloc(mq_size, 1)) == NULL){printf("   \n");exit(1);}
	mq_size--; //     
	if(!get_qs(in_buf, mq_size)){
		print_messages();
	}
	else{
		if(mq_send(mq_cmd, in_buf, strlen(in_buf), PRIO_MSG) < 0){
			printf("  \n");
		}
	}
	free(in_buf);
	free(out_buf);
	mq_close(mq_out);
	mq_close(mq_cmd);
	exit(0);
}

