#ifndef _FUNC_H_
#define _FUNC_H_
//    
#define STEP	0 //  
#define DPM1	1 //    
#define DPM2	2 //    
#define DPM12	3 //    
#define MOTOR_X	0  //  XY
#define MOTOR_Y	1<<5 //
#include "queues.h"
//    main.c
#ifdef FUNC_C
extern unsigned char addr;
extern int comfd;
extern FILE* outfile;
extern int send_cmd(unsigned char cmd, unsigned char flag, unsigned char cno);
extern void sendword(unsigned int data);
extern double dtime();
extern unsigned char read_tty();
#endif // FUNC_C

//    func.c
void corrector(unsigned char cno, const unsigned char dir, char *val);
void set_numdev(unsigned char cno, char *val);
void set_dev(unsigned char cno, char *val);
void set_voltage(unsigned char cno,  char *val);
void rotate_left(unsigned char cno, char *dev);
void steps_(unsigned char cno, char dir, char *val);
void rotate_right(unsigned char cno, char *dev);
void stop_motor(unsigned char cno, char *dev);
void terminals(unsigned char cno);
void set_timer(unsigned char cno, char *val);
void error(unsigned char err, unsigned char cno); //  
void switch_dev(unsigned char cno, unsigned char dev, unsigned char cmd_step, unsigned char cmd_drm1, unsigned char cmd_drm2, unsigned char cmd_drm12);
int goto_middle(unsigned char cno);
int init_motor(unsigned char cno);
#endif // _FUNC_H_
